:root {
  --grid-gutter: var(--grid-xs-gutter-default);
  --grid-margin: var(--grid-xs-margin-default);
}

/* Containers */
.container,
.container-fluid,
.container-sm,
.container-md,
.container-lg,
.container-xl {
  margin-left: auto;
  margin-right: auto;
  padding-left: var(--grid-margin);
  padding-right: var(--grid-margin);
  width: 100%;
}

/* Densidades dos Containers */
.container.density-low,
.container-fluid.density-low,
.container-sm.density-low,
.container-md.density-low,
.container-lg.density-low,
.container-xl.density-low {
  --grid-margin: var(--grid-xs-gutter-density-low);
}

.container.density-high,
.container-fluid.density-high,
.container-sm.density-high,
.container-md.density-high,
.container-lg.density-high,
.container-xl.density-high {
  --grid-margin: var(--grid-xs-gutter-density-high);
}

/* Linha */
.row {
  display: flex;
  flex-wrap: wrap;
  margin-left: calc(var(--grid-gutter) * -0.5);
  margin-right: calc(var(--grid-gutter) * -0.5);
}

.row.density-low {
  --grid-gutter: var(--grid-xs-gutter-density-low);
}

.row.density-high {
  --grid-gutter: var(--grid-xs-gutter-density-high);
}

/* Colunas */
.col,
[class*="col-"] {
  min-width: 25%;
  padding-left: calc(var(--grid-gutter) / 2);
  padding-right: calc(var(--grid-gutter) / 2);
  width: 100%;
}

.col {
  flex: 1 0 0%;
}

.col-auto {
  flex: 0 0 auto;
  width: auto;
}

.col-1 {
  flex-basis: 8.33%;
  max-width: 8.33%;
}

.col-2 {
  flex-basis: 16.67%;
  max-width: 16.67%;
}

.col-3 {
  flex-basis: 25%;
  max-width: 25%;
}

.col-4 {
  flex-basis: 33.33%;
  max-width: 33.33%;
}

.col-5 {
  flex-basis: 41.67%;
  max-width: 41.67%;
}

.col-6 {
  flex-basis: 50%;
  max-width: 50%;
}

.col-7 {
  flex-basis: 58.33%;
  max-width: 58.33%;
}

.col-8 {
  flex-basis: 66.67%;
  max-width: 66.67%;
}

.col-9 {
  flex-basis: 75%;
  max-width: 75%;
}

.col-10 {
  flex-basis: 83.33%;
  max-width: 83.33%;
}

.col-11 {
  flex-basis: 91.67%;
  max-width: 91.67%;
}

.col-12 {
  flex-basis: 100%;
  max-width: 100%;
}

/* Breakpoint sm */
@media (width >= 576px) {
  :root {
    --grid-gutter: var(--grid-sm-gutter-default);
    --grid-margin: var(--grid-sm-margin-default);
  }

  .container.density-low,
  .container-fluid.density-low,
  .container-sm.density-low,
  .container-md.density-low,
  .container-lg.density-low,
  .container-xl.density-low {
    --grid-margin: var(--grid-sm-gutter-density-low);
  }

  .container.density-high,
  .container-fluid.density-high,
  .container-sm.density-high,
  .container-md.density-high,
  .container-lg.density-high,
  .container-xl.density-high {
    --grid-margin: var(--grid-sm-gutter-density-high);
  }

  .container,
  .container-sm {
    max-width: calc(var(--grid-sm-breakpoint) - var(--grid-margin) * 2);
  }

  .row.density-low {
    --grid-gutter: var(--grid-sm-gutter-density-low);
  }

  .row.density-high {
    --grid-gutter: var(--grid-sm-gutter-density-high);
  }

  .col-sm {
    flex: 1 0 0%;
    min-width: 8.33%;
  }

  .col-sm-auto {
    flex: 0 0 auto;
    width: auto;
  }

  .col-sm-1 {
    flex-basis: 8.33%;
    max-width: 8.33%;
  }

  .col-sm-2 {
    flex-basis: 16.67%;
    max-width: 16.67%;
  }

  .col-sm-3 {
    flex-basis: 25%;
    max-width: 25%;
  }

  .col-sm-4 {
    flex-basis: 33.33%;
    max-width: 33.33%;
  }

  .col-sm-5 {
    flex-basis: 41.67%;
    max-width: 41.67%;
  }

  .col-sm-6 {
    flex-basis: 50%;
    max-width: 50%;
  }

  .col-sm-7 {
    flex-basis: 58.33%;
    max-width: 58.33%;
  }

  .col-sm-8 {
    flex-basis: 66.67%;
    max-width: 66.67%;
  }

  .col-sm-9 {
    flex-basis: 75%;
    max-width: 75%;
  }

  .col-sm-10 {
    flex-basis: 83.33%;
    max-width: 83.33%;
  }

  .col-sm-11 {
    flex-basis: 91.67%;
    max-width: 91.67%;
  }

  .col-sm-12 {
    flex-basis: 100%;
    max-width: 100%;
  }
}

/* Breakpoint md */
@media (width >= 990px) {
  :root {
    --grid-gutter: var(--grid-md-gutter-default);
    --grid-margin: var(--grid-md-margin-default);
  }

  .container.density-low,
  .container-fluid.density-low,
  .container-sm.density-low,
  .container-md.density-low,
  .container-lg.density-low,
  .container-xl.density-low {
    --grid-margin: var(--grid-md-gutter-density-low);
  }

  .container.density-high,
  .container-fluid.density-high,
  .container-sm.density-high,
  .container-md.density-high,
  .container-lg.density-high,
  .container-xl.density-high {
    --grid-margin: var(--grid-md-gutter-density-high);
  }

  .container,
  .container-sm,
  .container-md {
    max-width: var(--grid-md-breakpoint);
  }

  .row.density-low {
    --grid-gutter: var(--grid-md-gutter-density-low);
  }

  .row.density-high {
    --grid-gutter: var(--grid-md-gutter-density-high);
  }

  .col-md {
    flex: 1 0 0%;
    min-width: 8.33%;
  }

  .col-md-auto {
    flex: 0 0 auto;
    width: auto;
  }

  .col-md-1 {
    flex-basis: 8.33%;
    max-width: 8.33%;
  }

  .col-md-2 {
    flex-basis: 16.67%;
    max-width: 16.67%;
  }

  .col-md-3 {
    flex-basis: 25%;
    max-width: 25%;
  }

  .col-md-4 {
    flex-basis: 33.33%;
    max-width: 33.33%;
  }

  .col-md-5 {
    flex-basis: 41.67%;
    max-width: 41.67%;
  }

  .col-md-6 {
    flex-basis: 50%;
    max-width: 50%;
  }

  .col-md-7 {
    flex-basis: 58.33%;
    max-width: 58.33%;
  }

  .col-md-8 {
    flex-basis: 66.67%;
    max-width: 66.67%;
  }

  .col-md-9 {
    flex-basis: 75%;
    max-width: 75%;
  }

  .col-md-10 {
    flex-basis: 83.33%;
    max-width: 83.33%;
  }

  .col-md-11 {
    flex-basis: 91.67%;
    max-width: 91.67%;
  }

  .col-md-12 {
    flex-basis: 100%;
    max-width: 100%;
  }
}

/* Breakpoint lg */
@media (width >= 1280px) {
  :root {
    --grid-gutter: var(--grid-lg-gutter-default);
    --grid-margin: var(--grid-lg-margin-default);
  }

  .container.density-low,
  .container-fluid.density-low,
  .container-sm.density-low,
  .container-md.density-low,
  .container-lg.density-low,
  .container-xl.density-low {
    --grid-margin: var(--grid-lg-gutter-density-low);
  }

  .container.density-high,
  .container-fluid.density-high,
  .container-sm.density-high,
  .container-md.density-high,
  .container-lg.density-high,
  .container-xl.density-high {
    --grid-margin: var(--grid-lg-gutter-density-high);
  }

  .container,
  .container-sm,
  .container-md,
  .container-lg {
    max-width: var(--grid-lg-breakpoint);
  }

  .row.density-low {
    --grid-gutter: var(--grid-lg-gutter-density-low);
  }

  .row.density-high {
    --grid-gutter: var(--grid-lg-gutter-density-high);
  }

  .col-lg {
    flex: 1 0 0%;
    min-width: 8.33%;
  }

  .col-lg-auto {
    flex: 0 0 auto;
    width: auto;
  }

  .col-lg-1 {
    flex-basis: 8.33%;
    max-width: 8.33%;
  }

  .col-lg-2 {
    flex-basis: 16.67%;
    max-width: 16.67%;
  }

  .col-lg-3 {
    flex-basis: 25%;
    max-width: 25%;
  }

  .col-lg-4 {
    flex-basis: 33.33%;
    max-width: 33.33%;
  }

  .col-lg-5 {
    flex-basis: 41.67%;
    max-width: 41.67%;
  }

  .col-lg-6 {
    flex-basis: 50%;
    max-width: 50%;
  }

  .col-lg-7 {
    flex-basis: 58.33%;
    max-width: 58.33%;
  }

  .col-lg-8 {
    flex-basis: 66.67%;
    max-width: 66.67%;
  }

  .col-lg-9 {
    flex-basis: 75%;
    max-width: 75%;
  }

  .col-lg-10 {
    flex-basis: 83.33%;
    max-width: 83.33%;
  }

  .col-lg-11 {
    flex-basis: 91.67%;
    max-width: 91.67%;
  }

  .col-lg-12 {
    flex-basis: 100%;
    max-width: 100%;
  }
}

/* Breakpoint xl */
@media (width >= 1600px) {
  :root {
    --grid-gutter: var(--grid-xl-gutter-default);
    --grid-margin: var(--grid-xl-margin-default);
  }

  .container.density-low,
  .container-fluid.density-low,
  .container-sm.density-low,
  .container-md.density-low,
  .container-lg.density-low,
  .container-xl.density-low {
    --grid-margin: var(--grid-xl-gutter-density-low);
  }

  .container.density-high,
  .container-fluid.density-high,
  .container-sm.density-high,
  .container-md.density-high,
  .container-lg.density-high,
  .container-xl.density-high {
    --grid-margin: var(--grid-xl-gutter-density-high);
  }

  .container,
  .container-sm,
  .container-md,
  .container-lg,
  .container-xl {
    max-width: var(--grid-xl-breakpoint);
  }

  .row.density-low {
    --grid-gutter: var(--grid-xl-gutter-density-low);
  }

  .row.density-high {
    --grid-gutter: var(--grid-xl-gutter-density-high);
  }

  .col-xl {
    flex: 1 0 0%;
    min-width: 8.33%;
  }

  .col-xl-auto {
    flex: 0 0 auto;
    width: auto;
  }

  .col-xl-1 {
    flex-basis: 8.33%;
    max-width: 8.33%;
  }

  .col-xl-2 {
    flex-basis: 16.67%;
    max-width: 16.67%;
  }

  .col-xl-3 {
    flex-basis: 25%;
    max-width: 25%;
  }

  .col-xl-4 {
    flex-basis: 33.33%;
    max-width: 33.33%;
  }

  .col-xl-5 {
    flex-basis: 41.67%;
    max-width: 41.67%;
  }

  .col-xl-6 {
    flex-basis: 50%;
    max-width: 50%;
  }

  .col-xl-7 {
    flex-basis: 58.33%;
    max-width: 58.33%;
  }

  .col-xl-8 {
    flex-basis: 66.67%;
    max-width: 66.67%;
  }

  .col-xl-9 {
    flex-basis: 75%;
    max-width: 75%;
  }

  .col-xl-10 {
    flex-basis: 83.33%;
    max-width: 83.33%;
  }

  .col-xl-11 {
    flex-basis: 91.67%;
    max-width: 91.67%;
  }

  .col-xl-12 {
    flex-basis: 100%;
    max-width: 100%;
  }
}

/* Fix para Containers dentro de Containers */
.container .container,
.container .container-fluid,
.container .container-sm,
.container .container-md,
.container .container-lg,
.container .container-xl,
.container-fluid .container,
.container-fluid .container-fluid,
.container-fluid .container-sm,
.container-fluid .container-md,
.container-fluid .container-lg,
.container-fluid .container-xl,
.container-sm .container,
.container-sm .container-fluid,
.container-sm .container-sm,
.container-sm .container-md,
.container-sm .container-lg,
.container-sm .container-xl,
.container-md .container,
.container-md .container-fluid,
.container-md .container-sm,
.container-md .container-md,
.container-md .container-lg,
.container-md .container-xl,
.container-lg .container,
.container-lg .container-fluid,
.container-lg .container-sm,
.container-lg .container-md,
.container-lg .container-lg,
.container-lg .container-xl,
.container-xl .container,
.container-xl .container-fluid,
.container-xl .container-sm,
.container-xl .container-md,
.container-xl .container-lg,
.container-xl .container-xl {
  padding-left: 0;
  padding-right: 0;
}
